"""
Django settings for AffichageDynamique project.

Generated by 'django-admin startproject' using Django 2.1.7.

For more information on this file, see
https://docs.djangoproject.com/en/2.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.1/ref/settings/
"""

import dj_database_url
import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.getenv(
    "SECRET_KEY", "o1(en$lqa0@k*#we79=ooqpuk#%wzqgj2qk!^t43pxdu(=^w_8"
)

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.getenv("DJANGO_ENV", "dev") == "dev"

ALLOWED_HOSTS = [os.getenv("ALLOWED_HOSTS", "affichage.bde-insa-lyon.fr"), "localhost"]
if DEBUG:
    ALLOWED_HOSTS.extend(["127.0.0.1"])
    ALLOWED_HOSTS.extend(["localhost"])

SITE_URL = os.environ.get("SITE_URL", "http://127.0.0.1:8080")
# Application definition

INSTALLED_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "app",
    "crispy_forms",
    "anymail",
    "bootstrap_datepicker_plus",
    "django_registration",
    "django_crontab",
    "hcaptcha",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

# Verifier que les clés de test du captcha ne sont pas utilisées
SILENCED_SYSTEM_CHECKS = ["captcha.recaptcha_test_key_error"]

ROOT_URLCONF = "AffichageDynamique.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [os.path.join(BASE_DIR, "templates")],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "app.context_processors.app_settings",
            ],
        },
    },
]

WSGI_APPLICATION = "AffichageDynamique.wsgi.application"

# Database
# https://docs.djangoproject.com/en/2.1/ref/settings/#databases

DATABASES = {
    "default": dj_database_url.config(
        default="sqlite:///" + os.path.join(BASE_DIR, "db.sqlite3"), conn_max_age=600
    )
}

# Password validation
# https://docs.djangoproject.com/en/2.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

# Internationalization
# https://docs.djangoproject.com/en/2.1/topics/i18n/

LANGUAGE_CODE = "fr-fr"

TIME_ZONE = "Europe/Paris"

USE_I18N = True

USE_L10N = True

USE_TZ = True
CRISPY_TEMPLATE_PACK = "bootstrap4"

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.1/howto/static-files/

CRONJOBS = [
    ("0 3 * * *", "app.cron.delete_old_content"),
    ("0 5 */3 * *", "app.cron.delete_image_orphan"),
    ("*/15 * * * *", "app.cron.notify_moderation"),
    ("0 6 * 1-6,9-12 *", "app.cron.notify_screen_hs"),
    ("0 1 */10 * *", "app.cron.delete_old_user"),
    ("0 * * * *", "app.cron.maj_event_pva"),
]

# FIX Variables d'environnement pas présentes dans cron
CRONTAB_COMMAND_PREFIX = ". /tmp/env.txt &&"

AFFICHAGE_APP = {
    "site": {
        "name": "AffichageDynamique",
        "litteral_name": "Affichage Dynamique",
        "url": os.environ.get("SITE_URL", "http://127.0.0.1:8000"),
        "contact_mail": os.environ.get("CONTACT_MAIL", "sia.support@asso-insa-lyon.fr"),
        "repository": {
            "url": "https://gitlab.com/sia-insa-lyon/BdEINSALyon/serveur-affichage-dynamique",
            "bugtracker": "https://gitlab.com/sia-insa-lyon/BdEINSALyon/serveur-affichage-dynamique/-/issues",
        },
        "editor": {
            "role": os.environ.get("MENTION_ROLE", "Président du BdE INSA Lyon"),
            "mail": os.environ.get("MENTION_MAIL", "sg@bde-insa-lyon.fr"),
            "phone": os.environ.get("MENTION_PHONE", "+33404040404"),
        },
    },
    "file": {"file_max_size": 20 * 1024 * 1024},  # 20Mo
}

STATIC_URL = "/static/"
STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")
STATICFILES_DIRS = (os.path.join(BASE_DIR, "static"),)

MEDIA_ROOT = os.path.join(BASE_DIR, "media")
MEDIA_URL = "/media/"
LOGIN_REDIRECT_URL = "/"
LOGOUT_REDIRECT_URL = "/"
ACCOUNT_ACTIVATION_DAYS = 7

# Email backend configuration
if os.environ.get("EMAIL_BACKEND", "mailjet") == "console":
    import sys

    EMAIL_BACKEND = "django.core.mail.backends.console.EmailBackend"
    print("Using console email backend", file=sys.stderr)
else:
    EMAIL_BACKEND = "anymail.backends.mailjet.EmailBackend"


ADMINS = [("Support SIA", os.getenv("ADMIN_EMAIL", "sia.support@asso-insa-lyon.fr"))]

ANYMAIL = {
    # (exact settings here depend on your ESP...)
    "MAILJET_API_KEY": os.getenv("MAILJET_API_KEY"),
    "MAILJET_SECRET_KEY": os.getenv("MAILJET_SECRET_KEY"),
    "SEND_DEFAULTS": {
        "tags": ["affichage-dynamique"],
        "track_clicks": False,
    },
}

DEFAULT_FROM_EMAIL = os.getenv("DEFAULT_FROM_EMAIL", "affichage@mg.bde-insa-lyon.fr")
EMAIL_SUBJECT_PREFIX = os.getenv("EMAIL_SUBJECT_PREFIX", "[Affichage Dynamique]")
SERVER_EMAIL = DEFAULT_FROM_EMAIL
DEFAULT_GROUP_PK = os.getenv("DEFAULT_GROUP_PK", 0)

HCAPTCHA_SITEKEY = os.getenv("HCAPTCHA_SITEKEY", "")
HCAPTCHA_SECRET = os.getenv("HCAPTCHA_SECRET", "")

RESTAURANTS_FEED_PK = os.getenv("RESTAURANTS_FEED_PK", 2)
RESTAURANTS_GROUP_PK = os.getenv("RESTAURANTS_GROUP_PK", 2)

# URL dont Affichage récuperera le contenu à afficher
API_EVENTS = os.getenv("API_EVENTS", "https://portail.asso-insa-lyon.fr/api/v1/events/")
DEFAULT_USERNAME_EVENT = os.getenv("DEFAULT_USERNAME_EVENT", "RespVA")
